#include <QtGui/QMouseEvent>
#include <QtGui/QBitmap>
#include <QtGui/QPainter>
#include <QtCore/QTimer>
#include <QDesktopWidget>
#include <QtDebug>
#include "gifwindow.h"

GifMaskWidget::GifMaskWidget(QWidget *parent)
    : QLabel(parent, Qt::FramelessWindowHint | Qt::Window), count(0), mirror(false)
{
    imageR.setFileName("../persian.gif");

    QDesktopWidget desktop;
    desktopRect = desktop.availableGeometry(desktop.primaryScreen());
    move(desktopRect.bottomLeft() + QPoint(0, -50));
    
    if(imageR.canRead()) {
       image = imageR.read();
       pix = QPixmap::fromImage(image);
       setPixmap(QPixmap::fromImage(image));
       setMask(pix.mask());
    } else {
        qDebug() << imageR.errorString();
        close();
    }

    QTimer *timer = new QTimer(this);
    connect(timer, SIGNAL(timeout()), this, SLOT(nextGifImage()));
    timer->start(70);
}

void GifMaskWidget::mousePressEvent(QMouseEvent* event)
{
    if(event->button() == Qt::RightButton) {
        close();
    } else {
        position = event->pos();
    }
}

void GifMaskWidget::mouseMoveEvent(QMouseEvent* event)
{
    move(event->globalPos() - position);
}

void GifMaskWidget::nextGifImage()
{
    if(imageR.canRead()) {
        image = imageR.read();
        if(mirror) image = image.mirrored(true,false);
        pix = QPixmap::fromImage(image);
        setPixmap(pix);
        setMask(pix.mask());
    } else {
        qDebug() << imageR.errorString();
        return;
    }

    count++;
    if (count == 11) {
        count = 0;
        imageR.setFileName("../persian.gif");
    }

    if(!mirror) {
        move(pos() + QPoint(7,0));
        if(desktopRect.width() - 116 < (pos().x()))
            mirror = true;
    } else {
        move(pos() - QPoint(7,0));
        if(!pos().x())
            mirror = false;
    }
}



